'use strict';

function usingProxy() {
	var usingProxyArg = !!process.argv.filter(function (arg) {
		return arg.indexOf('--proxy') === 0 || arg.indexOf('-pr') === 0 || arg.indexOf('-pxy') === 0;
	}).length;

	var hasGeneratedProxies = false;
	var proxiesDir = process.env.PWD + '/server/proxies';
	try {
		fs.lstatSync(proxiesDir);
		hasGeneratedProxies = true;
  } catch (e) {}
  
	return usingProxyArg || hasGeneratedProxies;
}

function findGatewayURL() {
  let gatewayURL='http://localhost';
  for (var i=0;i<process.argv.length;i++) {
    if (process.argv[i].indexOf('--proxy') === 0 || process.argv[i].indexOf('-pr') === 0 || process.argv[i].indexOf('-pxy') === 0) {
      gatewayURL = process.argv[i+1];
      break;
    }
  }
  return gatewayURL;
}

module.exports = function(environment) {
  let ENV = {
		"ember-validated-form": {
			label: {
				submit: "label.save"
			},
			css: {
				group: "form-group",
				radio: "radio",
				control: "form-control",
				label: "col-form-label",
				help: "small form-text text-danger",
				hint: "small form-text text-muted",
				checkbox: "checkbox",
				button: "btn btn-default",
				submit: "btn btn-primary",
				loading: "loading",
				valid: "is-valid",
				error: "is-invalid"
			}
		},

    modulePrefix: 'dummy',
    environment,
    rootURL: '/',
    gatewayURL: findGatewayURL(),
    locationType: 'auto',
    EmberENV: {
      FEATURES: {
        // Here you can enable experimental features on an ember canary build
        // e.g. 'with-controller': true
      },
      EXTEND_PROTOTYPES: {
        // Prevent Ember Data from overriding Date.parse.
        Date: false
      }
    },

    APP: {
      // Here you can pass flags/options to your application instance
      // when it is created
		proxy: usingProxy(),
    }
  };

  if (environment === 'development') {
    // ENV.APP.LOG_RESOLVER = true;
    // ENV.APP.LOG_ACTIVE_GENERATION = true;
    // ENV.APP.LOG_TRANSITIONS = true;
    // ENV.APP.LOG_TRANSITIONS_INTERNAL = true;
    // ENV.APP.LOG_VIEW_LOOKUPS = true;
  }

  if (environment === 'test') {
    // Testem prefers this...
    ENV.locationType = 'none';

    // keep test console output quieter
    ENV.APP.LOG_ACTIVE_GENERATION = false;
    ENV.APP.LOG_VIEW_LOOKUPS = false;

    ENV.APP.rootElement = '#ember-testing';
    ENV.APP.autoboot = false;
  }

  if (environment === 'production') {
    ENV.gatewayURL = 'https://dcftkivcqe.execute-api.us-east-1.amazonaws.com/staging';
    // here you can enable a production-specific feature
  }

  return ENV;
};
